=== debian/changelog ===
alamode (1.5.0-1) unstable; urgency=low

  * New upstream version 1.5.0

 -- Synge Todo <wistaria@phys.s.u-tokyo.ac.jp>  Mon, 29 Jul 2024 14:03:54 +0900

alamode (1.4.2-2) unstable; urgency=low

  * Add missing tool python script

 -- Synge Todo <wistaria@phys.s.u-tokyo.ac.jp>  Tue, 06 Feb 2024 16:05:30 +0900

alamode (1.4.2-1) unstable; urgency=low

  * New upstream version 1.4.2

 -- Synge Todo <wistaria@phys.s.u-tokyo.ac.jp>  Sat, 20 Jan 2024 21:50:48 +0900

alamode (1.3.0-2) unstable; urgency=low

  * Migrate to Python3

 -- Synge Todo <wistaria@phys.s.u-tokyo.ac.jp>  Sun, 03 Apr 2022 18:53:33 +0900

alamode (1.3.0-1) unstable; urgency=low

  * New upstream version 1.3.0

 -- Synge Todo <wistaria@phys.s.u-tokyo.ac.jp>  Sun, 06 Mar 2022 12:10:02 +0900

alamode (1.1.0-3) unstable; urgency=low

  * Moved analyzed_photons tool into /usr/share/alamode/tools

 -- Synge Todo <wistaria@phys.s.u-tokyo.ac.jp>  Tue, 14 May 2019 14:26:28 +0900

alamode (1.1.0-2) unstable; urgency=low

  * Added missing python scripts

 -- Synge Todo <wistaria@phys.s.u-tokyo.ac.jp>  Mon, 13 May 2019 14:41:09 +0900

alamode (1.1.0-1) unstable; urgency=low

  * Initial release for 1.1.0

 -- Synge Todo <wistaria@phys.s.u-tokyo.ac.jp>  Sun, 12 May 2019 20:40:02 +0900
